// class of common variables
var SKM = SKM || {};

SKM.KEY_ENTER = 13;

// Some of them are only for the web pages but there are only ja ane en pages, so they were not translated.
SKM.messageMap = SKM.messageMep || {};
var messageMap = {
	'ko' : {
		'm_home': '집',
		'm_back': '돌아 가기',
		'm_game': '경기',
		'm_art': '미술',
		'm_tool': '수단',
		'm_index': '색인',
		'm_translation_home': '번역 프로젝트',
		'm_bbs': '게시판',
		'm_to_top': '페이지 상단으로',
		"m_bgm": "BGM",
		"m_sound": "소리",
		'm_operation': '조작',
		'm_story': '이야기',
		'm_history': '역사',
		'm_material_list': '기재',
		'm_material_list_exp': '이 프로그램은 아래 사이트의 자료를 사용합니다. 그들에게 감사드립니다.',
		'm_distributor': '분배 자',
		'm_material': '자료',
		'm_scene': '장면',
		'm_mat_category_bgm': '- BGM',
		'm_mat_category_sound': '- 소리',
		'm_mat_category_image': '- 영상',
		'm_mat_category_lib': '- 도서관',
		'm_mat_header_lib': '이름 및 라이센스 링크',
		'm_english': '영어',
		'm_korean': '한국어',
		'm_portuguese': '포르투갈 인',
		'm_turkish': '터키의',
		'm_french': '프랑스 국민',
		'm_italian': '이탈리아 사람',
		'm_russian': '러시아인',
		'm_spanish': '스페인 사람',
		'm_indonesian': '인도네시아 인',
		'm_tagalog': '타갈로그어',
		'm_chinese': '중국어 간체',
		'm_chinese_tw': '중국어 번체',
		'm_japanese': '일본어',
		'm_vietnamese': '베트남 사람',
		'm_polish': '광택',
		'm_german': '독일'
	},
	'pt' : {
		'm_home': 'Casa',
		'm_back': 'Voltar',
		'm_game': 'Jogos',
		'm_art': 'Arte',
		'm_tool': 'Instrumento',
		'm_index': 'Índice',
		'm_translation_home': 'Projecto de tradução',
		'm_bbs': 'BBS',
		'm_to_top': 'Para o topo da página',
		"m_bgm": "BGM",
		"m_sound": "Som",
		'm_operation': 'operação',
		'm_story': 'História',
		'm_history': 'Histórico',
		'm_material_list': 'Materiais',
		'm_material_list_exp': 'Este programa usa materiais do abaixo locais. Lhes agradeça pelo trabalho deles/delas.',
		'm_distributor': 'Distribuidor',
		'm_material': 'Materiais',
		'm_scene': 'Cena',
		'm_mat_category_bgm': '- BGM',
		'm_mat_category_sound': '- Som',
		'm_mat_category_image': '- Imagem',
		'm_mat_category_lib': '- Biblioteca',
		'm_mat_header_lib': 'Nome e ligação de licença',
		'm_english': 'Inglês',
		'm_korean': 'Coreano',
		'm_portuguese': 'Português',
		'm_turkish': 'Turco',
		'm_french': 'Francês',
		'm_italian': 'Italiano',
		'm_russian': 'Russo',
		'm_spanish': 'Espanhol',
		'm_indonesian': 'Indonésio',
		'm_tagalog': 'Tagalog',
		'm_chinese': 'Chinês simplificado',
		'm_chinese_tw': 'Chinês tradicional',
		'm_japanese': 'Japonês',
		'm_vietnamese': 'Vietnamita',
		'm_polish': 'Polonês',
		'm_german': 'Niemiecki'
	},
	'tr' : {
		'm_home': 'ev',
		'm_back': 'Geri',
		'm_game': 'Oyun',
		'm_art': 'Sanat',
		'm_tool': 'Araç',
		'm_index': 'indeks',
		'm_translation_home': 'çeviri Projesi',
		'm_bbs': 'BBS',
		'm_to_top': 'Sayfa başına dön',
		"m_bgm": "BGM",
		"m_sound": "Ses",
		'm_operation': 'Operasyon',
		'm_story': 'Hikaye',
		'm_history': 'Tarih',
		'm_material_list': 'Malzemeler',
		'm_material_list_exp': 'Bu program aşağıdaki sitelerden malzemeler kullanmaktadır. Çalışmaları için teşekkür ederim.',
		'm_distributor': 'Distribütör',
		'm_material': 'Malzeme',
		'm_scene': 'Sahne',
		'm_mat_category_bgm': '- Arkaplan Müziği',
		'm_mat_category_sound': '- Ses',
		'm_mat_category_image': '- Görüntü',
		'm_mat_category_lib': '- Kütüphane',
		'm_mat_header_lib': 'İsim ve lisans bağlantısı',
		'm_english': 'İngilizce',
		'm_korean': 'Kore',
		'm_portuguese': 'Portekizce',
		'm_turkish': 'Türk',
		'm_french': 'Fransızca',
		'm_italian': 'İtalyan',
		'm_russian': 'Rusça',
		'm_spanish': 'İspanyol',
		'm_indonesian': 'Endonezya',
		'm_tagalog': 'Tagalog',
		'm_chinese': 'Basitleştirilmiş Çince',
		'm_chinese_tw': 'Geleneksel Çince',
		'm_japanese': 'Japonca',
		'm_vietnamese': 'Vietnam',
		'm_polish': 'Polonya',
		'm_german': 'Alman'
	},
	'fr' : {
		'm_home': 'Accueil',
		'm_back': 'Retour',
		'm_game': 'Jeu',
		'm_art': 'Art',
		'm_tool': 'Outil',
		'm_index': 'Indice',
		'm_translation_home': 'Projet de traduction',
		'm_bbs': 'BBS',
		'm_to_top': 'Haut de la page',
		"m_bgm": "Musique de fond",
		"m_sound": "Sou",
		'm_operation': 'Opération',
		'm_story': 'Récit',
		'm_history': 'Histoire',
		'm_material_list': 'Matériaux',
		'm_material_list_exp': 'Ce programme utilise du matériel provenant des sites ci-dessous. Remerciez-les pour leur travail.',
		'm_distributor': 'Distributeur',
		'm_material': 'Matériel',
		'm_scene': 'Scène',
		'm_mat_category_bgm': '- Musique',
		'm_mat_category_sound': '- Son',
		'm_mat_category_image': '- Image',
		'm_mat_category_lib': '- Bibliothèque',
		'm_mat_header_lib': 'Nom et lien de licence',
		'm_english': 'Anglais',
		'm_korean': 'Coréen',
		'm_portuguese': 'Portugais',
		'm_turkish': 'Turc',
		'm_french': 'Français',
		'm_italian': 'Italien',
		'm_russian': 'Russe',
		'm_spanish': 'Espanol',
		'm_indonesian': 'Indonésien',
		'm_tagalog': 'Tagalog',
		'm_chinese': 'Chinois simplifié',
		'm_chinese_tw': 'Chinois traditionnel',
		'm_japanese': 'Japonais',
		'm_vietnamese': 'Vietnamien',
		'm_polish': 'Polonais',
		'm_german': 'Allemand'
	},
	'it' : {
		'm_home': 'Casa',
		'm_back': 'Tornare',
		'm_game': 'Gioco',
		'm_art': 'Arte',
		'm_tool': 'Attrezzo',
		'm_index': 'Indice',
		'm_translation_home': 'Progetto di traduzione',
		'm_bbs': 'BBS',
		'm_to_top': 'Alla pagina top',
		"m_bgm": "Musica",
		"m_sound": "Suono",
		'm_operation': 'Operazione',
		'm_story': 'Storia',
		'm_history': 'Storia',
		'm_material_list': 'Materiale',
		'm_material_list_exp': 'Questo programma utilizza materiali dai siti seguenti. Grazie a loro per il loro lavoro.',
		'm_distributor': 'Distributore',
		'm_material': 'Materiale',
		'm_scene': 'Scena',
		'm_mat_category_bgm': '- Musica',
		'm_mat_category_sound': '- Suono',
		'm_mat_category_image': '- Immagine',
		'm_mat_category_lib': '- Biblioteca',
		'm_mat_header_lib': 'Nome e collegamento della licenza',
		'm_english': 'Inglese',
		'm_korean': 'Coreano',
		'm_portuguese': 'Portoghese',
		'm_turkish': 'Turco',
		'm_french': 'Français',
		'm_italian': 'Italiano',
		'm_russian': 'Russo',
		'm_spanish': 'Spagnolo',
		'm_indonesian': 'Indonesiano',
		'm_tagalog': 'Tagalog',
		'm_chinese': 'Cinese semplificato',
		'm_chinese_tw': 'Cinese tradizionale',
		'm_japanese': 'Giapponese',
		'm_vietnamese': 'Vietnamita',
		'm_polish': 'Polacco',
		'm_german': 'Tedesco'
	},
	'ru' : {
		'm_home': 'Главная',
		'm_back': 'Назад',
		'm_game': 'Игра',
		'm_art': 'Искусство',
		'm_tool': 'Инструмент',
		'm_index': 'Индекс',
		'm_translation_home': 'Проект перевода',
		'm_bbs': 'ВВС',
		'm_to_top': 'К началу страницы',
		"m_bgm": "Музыка",
		"m_sound": "Звук",
		'm_operation': 'Операция',
		'm_story': 'История',
		'm_history': 'История',
		'm_material_list': 'Материалы',
		'm_material_list_exp': 'Эта программа использует материалы с сайтов ниже. Спасибо им за их работу.',
		'm_distributor': 'Дистрибьютор',
		'm_material': 'Материал',
		'm_scene': 'Сцена',
		'm_mat_category_bgm': '- Музыка',
		'm_mat_category_sound': '- Звук',
		'm_mat_category_image': '- Образ',
		'm_mat_category_lib': '- Библиотека',
		'm_mat_header_lib': 'Имя и ссылка на лицензию',
		'm_english': 'Английский',
		'm_korean': 'Корейский',
		'm_portuguese': 'Португальский',
		'm_turkish': 'Турецкий',
		'm_french': 'Французский',
		'm_italian': 'Итальянский',
		'm_russian': 'Русский',
		'm_spanish': 'Испанский',
		'm_indonesian': 'Индонезийский',
		'm_tagalog': 'Тагальского',
		'm_chinese': 'Упрощенный китайский',
		'm_chinese_tw': 'Традиционный китайский',
		'm_japanese': 'Японский',
		'm_vietnamese': 'Вьетнамский',
		'm_polish': 'Польский',
		'm_german': 'Немецкий'
	},
	'es' : {
		'm_home': 'Casa',
		'm_back': 'Volver',
		'm_game': 'Juego',
		'm_art': 'Arte',
		'm_tool': 'Herramienta',
		'm_index': 'Índice',
		'm_translation_home': 'Proyecto de traducción',
		'm_bbs': 'BBS',
		'm_to_top': 'Ir al principio de la página',
		"m_bgm": "BGM",
		"m_sound": "Sonido",
		'm_operation': 'Operación',
		'm_story': 'Historia',
		'm_history': 'Historia',
		'm_material_list': 'Materiales',
		'm_material_list_exp': 'Este programa utiliza materiales de los siguientes sitios. Gracias por su trabajo.',
		'm_distributor': 'Distribuidor',
		'm_material': 'Material',
		'm_scene': 'Escena',
		'm_mat_category_bgm': '- BGM',
		'm_mat_category_sound': '- Sonido',
		'm_mat_category_image': '- Imagen',
		'm_mat_category_lib': '- Biblioteca',
		'm_mat_header_lib': 'Nombre y enlace de licencia',
		'm_english': 'Inglés',
		'm_korean': 'Coreano',
		'm_portuguese': 'Portugués',
		'm_turkish': 'Turco',
		'm_french': 'Francés',
		'm_italian': 'Italiano',
		'm_russian': 'Ruso',
		'm_spanish': 'Español',
		'm_indonesian': 'Indonesio',
		'm_tagalog': 'Tagalo',
		'm_chinese': 'Chino simplificado',
		'm_chinese_tw': 'Chino tradicional',
		'm_japanese': 'Japonés',
		'm_vietnamese': 'Vietnamita',
		'm_polish': 'Polaco',
		'm_german': 'Aleman'
	},
	'in' : {
		'm_home': 'Rumah',
		'm_back': 'Kembali',
		'm_game': 'Permainan',
		'm_art': 'Seni',
		'm_tool': 'Alat',
		'm_index': 'Indeks',
		'm_translation_home': 'Proyek penerjemahan',
		'm_bbs': 'BBS',
		'm_to_top': 'Ke halaman atas',
		"m_bgm": "BGM",
		"m_sound": "Suara",
		'm_operation': 'Operasi',
		'm_story': 'Cerita',
		'm_history': 'Sejarah',
		'm_material_list': 'Materi',
		'm_material_list_exp': 'Program ini menggunakan bahan dari situs di bawah ini. Berterimakasihlah atas pekerjaan mereka.',
		'm_distributor': 'Distributor',
		'm_material': 'Bahan',
		'm_scene': 'Tempat kejadian',
		'm_mat_category_bgm': '- BGM',
		'm_mat_category_sound': '- Suara',
		'm_mat_category_image': '- Gambar',
		'm_mat_category_lib': '- Perpustakaan',
		'm_mat_header_lib': 'Nama dan tautan lisensi',
		'm_english': 'Inggris',
		'm_korean': 'Korea',
		'm_portuguese': 'Portugis',
		'm_turkish': 'Turki',
		'm_french': 'Perancis',
		'm_italian': 'Italia',
		'm_russian': 'Rusia',
		'm_spanish': 'Spanyol',
		'm_indonesian': 'Bahasa Indonesia',
		'm_tagalog': 'Tagalog',
		'm_chinese': 'Orang Cina Sederhana',
		'm_chinese_tw': 'Bahasa Cina Tradisional',
		'm_japanese': 'Jepang',
		'm_vietnamese': 'Vietnam',
		'm_polish': 'Polandia',
		'm_german': 'Jerman'
	},
	'tl' : {
		'm_home': 'bahay',
		'm_back': 'Bumalik ka',
		'm_game': 'laro',
		'm_art': 'Art',
		'm_tool': 'Tool',
		'm_index': 'Index',
		'm_translation_home': 'translation Project',
		'm_bbs': 'BBS',
		'm_to_top': 'Sa pahina ng tuktok',
		"m_bgm": "BGM",
		"m_sound": "tunog",
		'm_operation': 'Operation',
		'm_story': 'Story',
		'm_history': 'History',
		'm_material_list': 'Materials',
		'm_material_list_exp': 'This program uses materials from the below sites. Thank them for their work.',
		'm_distributor': 'Distributor',
		'm_material': 'Material',
		'm_scene': 'Scene',
		'm_mat_category_bgm': '- BGM',
		'm_mat_category_sound': '- Sound',
		'm_mat_category_image': '- Image',
		'm_mat_category_lib': '- Library',
		'm_mat_header_lib': 'Name and license link',
		'm_english': 'Ingles',
		'm_korean': 'Koreano',
		'm_portuguese': 'Portuges',
		'm_turkish': 'Turko',
		'm_french': 'Pranses',
		'm_italian': 'Italyano',
		'm_russian': 'Ruso',
		'm_spanish': 'Espanyol',
		'm_indonesian': 'Indonesiyo',
		'm_tagalog': 'Tagalog',
		'm_chinese': 'Pinapayak na Tsino',
		'm_chinese_tw': 'Tradisyunal na Tsino',
		'm_japanese': 'Japanese',
		'm_vietnamese': 'Vietnamese',
		'm_polish': 'Polish',
		'm_german': 'Aleman'
	},
	'zh' : {
		'm_home': '家',
		'm_back': '返回',
		'm_game': '游戏',
		'm_art': 'Art',
		'm_tool': 'Tool',
		'm_index': '索引',
		'm_translation_home': '翻译项目',
		'm_bbs': 'BBS',
		'm_to_top': '返回页首',
		"m_bgm": "背景音乐",
		"m_sound": "音声",
		'm_operation': 'Operation',
		'm_story': 'Story',
		'm_history': 'History',
		'm_material_list': 'Materials',
		'm_material_list_exp': 'This program uses materials from the below sites. Thank them for their work.',
		'm_distributor': 'Distributor',
		'm_material': 'Material',
		'm_scene': 'Scene',
		'm_mat_category_bgm': '- BGM',
		'm_mat_category_sound': '- Sound',
		'm_mat_category_image': '- Image',
		'm_mat_category_lib': '- Library',
		'm_mat_header_lib': 'Name and license link',
		'm_english': '英语',
		'm_korean': '韩语',
		'm_portuguese': '葡萄牙语',
		'm_turkish': '土耳其',
		'm_french': '法语',
		'm_italian': '意大利语',
		'm_russian': '俄语',
		'm_spanish': '西班牙语',
		'm_indonesian': '印度尼西亚',
		'm_tagalog': '他加禄语',
		'm_chinese': '简体中文',
		'm_chinese_tw': '繁体中文',
		'm_japanese': '日语',
		'm_vietnamese': '越南',
		'm_polish': '抛光',
		'm_german': '德文'
	},
	'zh_TW' : {
		'm_home': '家',
		'm_back': '返回',
		'm_game': '遊戲',
		'm_art': 'Art',
		'm_tool': 'Tool',
		'm_index': '索引',
		'm_translation_home': '翻譯項目',
		'm_bbs': 'BBS',
		'm_to_top': '返回頁首',
		"m_bgm": "背景音樂",
		"m_sound": "音聲",
		'm_operation': 'Operation',
		'm_story': 'Story',
		'm_history': 'History',
		'm_material_list': 'Materials',
		'm_material_list_exp': 'This program uses materials from the below sites. Thank them for their work.',
		'm_distributor': 'Distributor',
		'm_material': 'Material',
		'm_scene': 'Scene',
		'm_mat_category_bgm': '- BGM',
		'm_mat_category_sound': '- Sound',
		'm_mat_category_image': '- Image',
		'm_mat_category_lib': '- Library',
		'm_mat_header_lib': 'Name and license link',
		'm_english': '英語',
		'm_korean': '韓語',
		'm_portuguese': '葡萄牙語',
		'm_turkish': '土耳其',
		'm_french': '法語',
		'm_italian': '意大利語',
		'm_russian': '俄語',
		'm_spanish': '西班牙語',
		'm_indonesian': '印度尼西亚',
		'm_tagalog': '他加祿語',
		'm_chinese': '簡體中文',
		'm_chinese_tw': '繁體中文',
		'm_japanese': '日語',
		'm_vietnamese': '越南',
		'm_polish': '拋光',
		'm_german': '德文'
	},
	'vi' : {
		'm_home': 'Nhà',
		'm_back': 'Trở lại',
		'm_game': 'Game',
		'm_art': 'Nghệ thuật',
		'm_tool': 'Dụng cụ',
		'm_index': 'Mục lục',
		'm_translation_home': 'Dự án dịch',
		'm_bbs': 'BBS',
		'm_to_top': 'Về đầu trang',
		"m_bgm": "BGM",
		"m_sound": "Âm thanh",
		'm_operation': 'Hoạt động',
		'm_story': 'Câu chuyện',
		'm_history': 'Lịch sử',
		'm_material_list': 'Nguyên vật liệu',
		'm_material_list_exp': 'Chương trình này sử dụng tài liệu từ các trang web dưới đây. Cảm ơn họ vì công việc của họ.',
		'm_distributor': 'Nhà phân phối',
		'm_material': 'Vật chất',
		'm_scene': 'Bối cảnh',
		'm_mat_category_bgm': '- BGM',
		'm_mat_category_sound': '- Âm thanh',
		'm_mat_category_image': '- Hình ảnh',
		'm_mat_category_lib': '- Thư viện',
		'm_mat_header_lib': 'Liên kết tên và giấy phép',
		'm_english': 'Anh',
		'm_korean': 'Hàn Quốc',
		'm_portuguese': 'Tiếng Bồ Đào Nha',
		'm_turkish': 'Tiếng Thổ Nhĩ Kỳ',
		'm_french': 'người Pháp',
		'm_italian': 'người Ý',
		'm_russian': 'Người Nga',
		'm_spanish': 'người Tây Ban Nha',
		'm_indonesian': 'Người Indonesia',
		'm_tagalog': 'Tiếng Tagalog',
		'm_chinese': 'Tiếng Trung giản thể',
		'm_chinese_tw': 'Tiếng Trung phồn thể',
		'm_japanese': 'tiếng Nhật',
		'm_vietnamese': 'Tiếng Việt',
		'm_polish': 'đánh bóng',
		'm_german': 'Tiếng Đức'
	},
	'pl' : {
		'm_home': 'Dom',
		'm_back': 'Z powrotem',
		'm_game': 'Gra',
		'm_art': 'Sztuka',
		'm_tool': 'Narzędzie',
		'm_index': 'Indeks',
		'm_translation_home': 'Projekt tłumaczenia',
		'm_bbs': 'BBS',
		'm_to_top': 'Do góry strony',
		"m_bgm": "BGM",
		"m_sound": "Dźwięk",
		'm_operation': 'Operacja',
		'm_story': 'Fabuła',
		'm_history': 'Historia',
		'm_material_list': 'Materiały',
		'm_material_list_exp': 'Ten program wykorzystuje materiały z poniższych stron. Dziękuję im za ich pracę.',
		'm_distributor': 'Dystrybutor',
		'm_material': 'Materiał',
		'm_scene': 'Scena',
		'm_mat_category_bgm': '- BGM',
		'm_mat_category_sound': '- Dźwięk',
		'm_mat_category_image': '- Obraz',
		'm_mat_category_lib': '- Biblioteka',
		'm_mat_header_lib': 'Nazwa i link licencyjny',
		'm_english': 'Język angielski',
		'm_korean': 'Koreański',
		'm_portuguese': 'Portugalski',
		'm_turkish': 'Turecki',
		'm_french': 'Francuski',
		'm_italian': 'Włoski',
		'm_russian': 'Rosyjski',
		'm_spanish': 'Hiszpański',
		'm_indonesian': 'indonezyjski',
		'm_tagalog': 'Tagalog',
		'm_chinese': 'Chiński uproszczony',
		'm_chinese_tw': 'Chiński Tradycyjny',
		'm_japanese': 'Język japoński',
		'm_vietnamese': 'Wietnamski',
		'm_polish': 'Polskie',
		'm_german': 'Niemiecki'
	},
	'de' : {
		'm_home': 'Zuhause',
		'm_back': 'Zurück',
		'm_game': 'Spiel',
		'm_art': 'Art',
		'm_tool': 'Tool',
		'm_index': 'Index',
		'm_translation_home': 'Übersetzungsprojekt',
		'm_bbs': 'BBS',
		'm_to_top': 'Zum Seitenanfang',
		"m_bgm": "BGM",
		"m_sound": "Klang",
		'm_operation': 'Betrieb',
		'm_story': 'Geschichte',
		'm_history': 'Geschichte',
		'm_material_list': 'Materialien',
		'm_material_list_exp': 'Dieses Programm verwendet Materialien von den folgenden Seiten. Danke ihnen für ihre Arbeit.',
		'm_distributor': 'Verteiler',
		'm_material': 'Material',
		'm_scene': 'Szene',
		'm_mat_category_bgm': '- BGM',
		'm_mat_category_sound': '- Klang',
		'm_mat_category_image': '- Bild',
		'm_mat_category_lib': '- Bibliothek',
		'm_mat_header_lib': 'Name und Lizenzlink',
		'm_english': 'Englisch',
		'm_korean': 'Koreanisch',
		'm_portuguese': 'Portugiesisch',
		'm_turkish': 'Türkisch',
		'm_french': 'Französisch',
		'm_italian': 'Italienisch',
		'm_russian': 'Russisch',
		'm_spanish': 'Spanisch',
		'm_indonesian': 'Indonesisch',
		'm_tagalog': 'Tagalog',
		'm_chinese': 'Vereinfachtes Chinesisch',
		'm_chinese_tw': 'Traditionelles Chinesisch',
		'm_japanese': 'japanisch',
		'm_vietnamese': 'Vietnamesisch',
		'm_polish': 'Polieren',
		'm_german': 'Deutsche'
	},
	'en' : {
		'm_home': 'Home',
		'm_back': 'Back',
		'm_game': 'Game',
		'm_art': 'Art',
		'm_tool': 'Tool',
		'm_index': 'Index',
		'm_translation_home': 'Translation Project',
		'm_bbs': 'BBS',
		'm_to_top': 'To page top',
		"m_bgm": "BGM",
		"m_sound": "Sound",
		'm_operation': 'Operation',
		'm_story': 'Story',
		'm_history': 'History',
		'm_material_list': 'Materials',
		'm_material_list_exp': 'This program uses materials from the below sites. Thank them for their work.',
		'm_distributor': 'Distributor',
		'm_material': 'Material',
		'm_scene': 'Scene',
		'm_mat_category_bgm': '- BGM',
		'm_mat_category_sound': '- Sound',
		'm_mat_category_image': '- Image',
		'm_mat_category_lib': '- Library',
		'm_mat_header_lib': 'Name and license link',
		'm_english': 'English',
		'm_korean': 'Korean',
		'm_portuguese': 'Portuguese',
		'm_turkish': 'Turkish',
		'm_french': 'French',
		'm_italian': 'Italian',
		'm_russian': 'Russian',
		'm_spanish': 'Spanish',
		'm_indonesian': 'Indonesian',
		'm_tagalog': 'Tagalog',
		'm_chinese': 'Simplified Chinese',
		'm_chinese_tw': 'Traditional Chinese',
		'm_japanese': 'Japanese',
		'm_vietnamese': 'Vietnamese',
		'm_polish': 'Polish',
		'm_german': 'German'
	},
	'ja' : {
		'm_home': 'ホーム',
		'm_back': '戻る',
		'm_game': 'ゲーム',
		'm_art': 'アート',
		'm_tool': 'ツール',
		'm_index': '目次',
		'm_translation_home': '翻訳プロジェクト',
		'm_bbs': 'BBS',
		'm_to_top': 'ページトップへ',
		"m_bgm": "BGM",
		"m_sound": "サウンド",
		'm_operation': '操作方法',
		'm_story': 'ストーリー',
		'm_history': '更新履歴',
		'm_material_list': '使用素材一覧',
		'm_material_list_exp': '本プログラムでは以下の素材を使用しています。素材提供者の方々に感謝いたします。（以下順不同）',
		'm_distributor': '素材提供者',
		'm_material': '素材',
		'm_scene': '使用シーン',
		'm_mat_category_bgm': '◆BGM',
		'm_mat_category_sound': '◆効果音',
		'm_mat_category_image': '◆画像',
		'm_mat_category_lib': '◆ライブラリ',
		'm_mat_header_lib': 'ライブラリ名・ライセンスリンク',
		'm_english': '英語',
		'm_korean': '韓国語',
		'm_portuguese': 'ポルトガル語',
		'm_turkish': 'トルコ語',
		'm_french': 'フランス語',
		'm_italian': 'イタリア語',
		'm_russian': 'ロシア語',
		'm_spanish': 'スペイン語',
		'm_indonesian': 'インドネシア語',
		'm_tagalog': 'タガログ語',
		'm_chinese': '中国語簡体字',
		'm_chinese_tw': '中国語繁体字',
		'm_japanese': '日本語',
		'm_vietnamese': 'ベトナム語',
		'm_polish': 'ポーランド語',
		'm_german': 'ドイツ語'
	}
};
for (key in messageMap) {
	SKM.messageMap[key] = messageMap[key];
}

SKM.setOnLoad = function(onLoad) {
	if (window.addEventListener) { //for W3C DOM
		window.addEventListener("load", onLoad, false);
	} else if (window.attachEvent) { //for IE
		window.attachEvent("onload", onLoad);
	} else {
		window.onload = onLoad;
	}
};

SKM.switchTagDisplay = function(lang, checkLangs) {
	for (var i = 0; i < checkLangs.length; ++i) {
		var checkLang = checkLangs[i];
		var elems = document.getElementsByClassName(checkLang + "_only");
		var isLang = (lang === checkLang);
		for (var j = elems.length - 1; 0 <= j; --j) {
			elems[j].style.display = (isLang ? '' : 'none');
		}
	}
};

SKM.switchTagDisplayNoJ = function() {
	var params = SKM.splitQueryString();
	if (params['ad'] === '1') {
		return;
	}
	var systemLang = SKM.getBrowserLang();
	var isLang = systemLang === "ja";
	if (isLang) {
		var elems = document.getElementsByClassName("noj");
		for (var j = elems.length - 1; 0 <= j; --j) {
			elems[j].style.display = 'none';
		}
	}
};

SKM.translateWords = function(messageMap, isUseBrowserLang, fixedLang) {
	var defaultLang = 'en';
	var params = SKM.splitQueryString();
	var lang = params.lang;
	if (lang === undefined && isUseBrowserLang) {
		lang = (navigator.userLanguage || navigator.browserLanguage || navigator.language).substr(0, 2);
	}
	if (!lang || (messageMap && !(lang in messageMap))) {
		lang = defaultLang;
	}
	if (fixedLang) {
		lang = fixedLang;
	}
	var messages = SKM.messageMap[lang];
	if (lang in messageMap) {
		for (key in messageMap[lang]) {
			messages[key] = messageMap[lang][key];
		}
	}
	for (key in messages) {
		var elems = document.getElementsByClassName(key);
		for (var i = elems.length - 1; 0 <= i; --i) {
			elems[i].textContent = messages[key];
		}
		if (key === 'm_title') {
			var titleTag = document.getElementsByTagName('title');
			if (titleTag.length !== 0) {
				titleTag[0].textContent = messages[key];
			}
		}
	}
	return lang;
};

SKM.setLangToLinks = function(lang, isForce) {
	var links = document.getElementsByTagName('a');
	var paramLang = 'lang=' + lang;
	for (var i = 0; i < links.length; ++i) {
		var href = links[i].href;
		var langIndex = href.indexOf('lang=');
		if (langIndex === -1) {
			if (href.indexOf('?') === -1) {
				links[i].href = href + '?' + paramLang;
			} else {
				links[i].href = href + '&' + paramLang;
			}
		} else {
			links[i].href = href.replace(/lang=[a-zA-Z]+/, paramLang);
		}
	}
};

SKM.getSelectedValue = function(selectId) {
	var elem = document.getElementById(selectId);
	if (elem && elem.selectedIndex != -1) {
		return elem.options[elem.selectedIndex].value;
	}
	return null;
};

/**
 * ユーザ入力をHTML表示する際に使用すること。
 */
SKM.escapeTag = function(data) {
	data = data.replace(/</g, '&lt;');
	return data;
};

/**
 * ユーザ入力をHTML表示する際に使用すること。
 */
SKM.escapeInput = function(data) {
	data = data.replace(/\\/g, '\\\\');
	data = data.replace(/"/g, '\\"');
	data = data.replace(/'/g, "\\'");
	data = data.replace(/</g, '&lt;');
	return data;
};

SKM.execPost = function(uri, data, encType) {
	var form = document.createElement('form');
	form.setAttribute('action', uri);
	form.setAttribute('method', 'post');
	if (arguments.length == 3) {
		form.setAttribute('enctype', encType);
	}
	form.style.visible = 'hidden';
	document.body.appendChild(form);
	for (var key in data) {
		var input = document.createElement('input');
		input.setAttribute('type', 'hidden');
		input.setAttribute('name', key);
		input.setAttribute('value', data[key]);
		form.appendChild(input);
	}
	form.submit();
};

SKM.splitQueryString = function() {
	if (window.location.search.length == 0) {
		return [];
	}
	var query = window.location.search.substring(1);
	var params = query.split('&');
	var ret = [];
	for (var i = 0; i < params.length; ++i) {
		var tokens = params[i].split('=');
		var key = decodeURIComponent(tokens[0]);
		var value = decodeURIComponent(tokens[1]);
		ret[key] = value;
	}
	return ret;
};

/**
 * @param type 下記のいずれかの文字列。
 * 'String'
 * 'Number'
 * 'Boolean'
 * 'Date'
 * 'Error'
 * 'Array'
 * 'Function'
 * 'RegExp'
 * 'Object'
 * 'ImageData'
 */
SKM.is = function(obj, type) {
	var clas = Object.prototype.toString.call(obj).slice(8, -1);
	return obj !== undefined && obj !== null && clas === type;
};

SKM.loadJson = function(filepath, callback, postData, formData, isAllowJsonOnly) {
	var req = new XMLHttpRequest();
	if (formData) {
		req.open('post', filepath);
		if (postData) {
			for (var key in postData) {
				formData.append(key, postData[key]);
			}
		}
		postData = formData;
	} else if (postData) {
		req.open('post', filepath);
		req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
		if (SKM.is(postData, 'Object')) {
			postData = SKM.encodePostData(postData);
		}
	} else {
		req.open('get', filepath);
		postData = null;
	}
	req.onreadystatechange = function() {
		if (req.readyState == 4) {
			if (req.status == 404) {
				// エラー
				console.log('SKM.loadJson(): failed to load file: ' + filepath);
				callback(null);
				return;
			}
			if (0 < req.responseText.length) {
				var json = null;
				try {
					json = JSON.parse(req.responseText);
				} catch (e) {
					if (isAllowJsonOnly) {
						callback(null);
					} else {
						callback(req.responseText);
					}
					return;
				}
				callback(json);
			} else {
				callback(null);
			}
		}
	};
	try {
		req.send(postData);
	} catch (e) {
		console.log('SKM.loadJson(): cannot load file because cross domain access.');
		callback(null);
	}
};

SKM.encodePostData = function(data) {
	var params = [];
	for (var name in data) {
		params.push(encodeURIComponent(name).replace(/%20/g, '+') + '=' +
					encodeURIComponent(data[name]).replace(/%20/g, '+'));
	}
	return params.join('&');
};

SKM.getPlatform = function() {
	var userAgent = navigator.userAgent.toLowerCase();
	if (userAgent.indexOf('iphone') != -1) {
		return 'iphone';
	} else if (userAgent.indexOf('ipad') != -1) {
		return 'ipad';
	} else if (userAgent.indexOf('ipod') != -1) {
		return 'ipod';
	} else if (userAgent.indexOf('android') != -1) {
		return 'android';
	}
	return 'pc';
};

SKM.isPc = function() {
	return SKM.getPlatform() == 'pc';
};

SKM.isAvailableLocalStorage = function() {
	var test = 'tomato_cabbage';
	try {
		localStorage.setItem(test, test);
		localStorage.removeItem(test);
	} catch (e) {
		return false;
	}
	return true;
};

SKM.setVd = function(vd) {
	localStorage.setItem('vd', vd);
};

SKM.getVd = function() {
	return localStorage.getItem('vd');
};

SKM.getBrowserLang = function() {
	try {
		var ua = window.navigator.userAgent.toLowerCase();
		if (ua.indexOf('chrome') !== -1 ) {
			return (navigator.languages[0] || navigator.browserLanguage || navigator.language || navigator.userLanguage).substr(0, 2);
		} else {
			return (navigator.browserLanguage || navigator.language || navigator.userLanguage).substr(0, 2);
		}
	} catch(e) {
		return 'en';
	}
};

SKM.parseHtmlFromString = function(markup) {
	var doc = document.implementation.createHTMLDocument("")
	  , doc_elt = doc.documentElement
	  , first_elt;

	doc_elt.innerHTML = markup;
	first_elt = doc_elt.firstElementChild;

	if (doc_elt.childElementCount === 1
		&& first_elt.localName.toLowerCase() === "html") {
		doc.replaceChild(first_elt, doc_elt);
	}

	return doc;
};
